#include <Astri_Monitor.h>
using namespace inaf::oasbo::PacketMonitors;

AstriPacketMonitorBuilder::AstriPacketMonitorBuilder() {
	this->reset();
}

AstriPacketMonitorBuilder::~AstriPacketMonitorBuilder() {
	delete monitor;
}

void AstriPacketMonitorBuilder::reset() {
	this->monitor = new AstriPacketMonitor();
}

AstriPacketMonitorBuilder* AstriPacketMonitorBuilder::configFrom(Configurators::BaseConfigurator &conf) {
	conf.readConfigFromSource(config_target);
	std::map<std::string, std::string> params = conf.getConfig();

	std::string key = config_target+"_"+interval_key;
	if (params.count(key) > 0){
		int interval = 0;
		try{
			interval = std::stoi(params[key]);
			this->monitor->setUpdateInterval(interval);
		}
		catch (const std::invalid_argument& e){
			// just keep the old value.
		}
	}

	return this;
}

AstriPacketMonitorBuilder* AstriPacketMonitorBuilder::setUpdateInterval(int interval) {
	monitor->setUpdateInterval(interval);
	return this;
}


AstriPacketMonitor* AstriPacketMonitorBuilder::getMonitor() {
	AstriPacketMonitor *result = this->monitor;
	this->reset();
	return result;
}
